//+------------------------------------------------------------------+
//|                                      SharkFX-Newbie-expert.mq4   |
//|                                       Copyright  2015, SharkFX  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2015, SharkFX"
#property link      "SharkFX.ru"

#property description "     "
#property description "     http://sharkfx.ru"
#property strict

#include <stdlib.mqh>
#include <WinUser32.mqh>

// exported variables

enum Indicators
  {
   None=0,
   MovingAverage=1,         //MovingAverage
   MACD=2,                  //MACD
   HeikenAshi=3,           //HeikenAshi
   AwesomeOscillator=4,     //AwesomeOscillator
   Parabolic=5,             //Parabolic
   RSI=6,                   //RSI
   CCI=7,                   //CCI
   WPR=8,                   //WPR
   Stochastic=9,            //Stochastic 
   DeMarker=10,              //DeMarker
   
  };

extern int StopLoss = 30;
extern int TakeProfit = 30;
extern double Lots = 0.1;
extern bool Martingale = false;
extern double LotMultiple = 2;
extern string ChooseIndicators = "-----------------------------------------------------------";  //   3- 
extern Indicators Indicator = MovingAverage;
extern Indicators Indicator2 = None;
extern Indicators Indicator3 = None;

extern string IndicatoSettings = "-----------------------------------------------------------";  //  
// Moving average cross
extern int SlowMaPeriod = 30;
extern int FastMaPeriod = 14;
enum Methods
  {
   Simple=MODE_SMA,        // Simple
   Exponential=MODE_EMA,   // Exponential 
   Smoothed=MODE_SMMA,     // Smoothed
   LinWeighted=MODE_LWMA,  // LinWeighted
  };
extern Methods MaMethod = Simple;

// MACD
extern int MACDFast = 12;
extern int MACDSlow = 26;
extern int MACDma = 9;

// Parabolic
extern double ParabolicStep = 0.02;
extern double ParabolicMax = 0.2;

// RSI
extern int RsiPeriod = 14;
extern int RsiSignal = 70;

// CCI
extern int CCIPeriod = 14;
extern int CCISignal = 100;

// WPR
extern int WPRPeriod = 14;
extern int WPRSignal = -20;

// Stochastic
extern int StochKperiod = 5;
extern int StochDperiod = 3;
extern int StochSlow = 3;
extern int StochSignal = 80;
extern Methods StochMethod = Simple;

// DeMark
extern int DeMarkPeriod = 14;
extern double DeMarkSignal = 0.7;

int OpenOrderStopLossimit = 1;
int SignalCount = 0;
   

// local variables
double PipValue=1;    // this variable is here to support 5-digit brokers
bool Terminated = false;
string LF = "\n";  // use this in custom or utility blocks where you need line feeds
int NDigits = 4;   // used mostly for NormalizeDouble in Flex type blocks
int ObjCount = 0;  // count of all objects created on the chart, allows creation of objects with unique names
int current = 0;

datetime BarTime1 = 0;
double CurrentBuyLots = 1;
bool FirstBuyLotsMgm = true;
double CurrentSellLots = 1;
bool FirstSellLotsMgm = true;


int init()
{
    NDigits = Digits;
    
    if (false) ObjectsDeleteAll();      // clear the chart
    
    CurrentBuyLots = Lots;
    
    CurrentSellLots = Lots;
    
    if (Indicator > 0) SignalCount++;
    if (Indicator2 > 0) SignalCount++;
    if (Indicator3 > 0) SignalCount++;
    Comment("");    // clear the chart
    return (0);
}

// Expert start
int start()
{
    if (Bars < 10)
    {
        Comment("Not enough bars");
        return (0);
    }
    if (Terminated == true)
    {
        Comment("EA Terminated.");
        return (0);
    }

    OnEveryNewBar();
    return (0);
}

void OnEveryNewBar()
{
    if (true == false && false) PipValue = 10;
    if (true && (NDigits == 3 || NDigits == 5)) PipValue = 10;
    if (BarTime1 < Time[0])
    {
        // we have a new bar opened
        BarTime1 = Time[0]; // keep the new bar open time
        LimitOpenOrders();
        
    }
}

void LimitOpenOrders()
{
    int count = 0;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderSymbol() == Symbol())
        if (OrderMagicNumber() == 1)
        {
            count++;
        }
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
    if (count < OpenOrderStopLossimit)
    {
        TechnicalAnalysis();
        
    }
}

void TechnicalAnalysis()
{
    int SignalToBuy = 0;
    int SignalToSell = 0;
    if (Indicator == 1 || Indicator2 == 1 || Indicator3 == 1) {
          string PushMethod = MaMethod;
          double SlowMaCurrent = iMA(NULL, NULL,SlowMaPeriod,0,PushMethod,PRICE_CLOSE,1);
          double FastMaCurrent = iMA(NULL, NULL,FastMaPeriod,0,PushMethod,PRICE_CLOSE,1);
          if (SlowMaCurrent < FastMaCurrent) SignalToBuy++;
          if (SlowMaCurrent > FastMaCurrent) SignalToSell++;
    }
    if (Indicator == 2 || Indicator2 == 2 || Indicator3 == 2) {
          double MACDCurrent = iMACD(NULL,NULL,MACDFast,MACDSlow,MACDma,PRICE_CLOSE,MODE_MAIN,0); 
          if (MACDCurrent > 0) SignalToBuy++;
          if (MACDCurrent < 0) SignalToSell++;
    }
    if (Indicator == 3 || Indicator2 == 3 || Indicator3 == 3) {
          double  haOpen = iCustom(NULL,NULL,"Heiken Ashi",Red,White,Red,White,2,1);
          double  haClose = iCustom(NULL,NULL,"Heiken Ashi",Red,White,Red,White,3,1);
          if (haOpen < haClose) SignalToBuy++;
          if (haOpen > haClose) SignalToSell++;
    }
    if (Indicator == 4 || Indicator2 == 4 || Indicator3 == 4) {
          double AOCurrent = iAO(NULL,NULL,1); 
          if (AOCurrent > 0) SignalToBuy++;
          if (AOCurrent < 0) SignalToSell++;
    }
     if (Indicator == 5 || Indicator2 == 5 || Indicator3 == 5) {
          double ParabolicCurrent = iSAR(NULL,NULL,ParabolicStep,ParabolicMax,1); 
          if (ParabolicCurrent < Bid) SignalToBuy++;
          if (ParabolicCurrent > Bid) SignalToSell++;
    }
    if (Indicator == 6 || Indicator2 == 6 || Indicator3 == 6) {
          double RsiCurrent = iRSI(NULL, NULL,RsiPeriod,PRICE_CLOSE,1);       
          if (RsiCurrent < 100 - RsiSignal) SignalToBuy++;
          if (RsiCurrent > RsiSignal) SignalToSell++;
    }
    if (Indicator == 7 || Indicator2 == 7 || Indicator3 == 7) {
          double CCICurrent = iCCI(NULL, NULL,CCIPeriod,PRICE_CLOSE,1);       
          if (CCICurrent < CCISignal*-1) SignalToBuy++;
          if (CCICurrent > CCISignal) SignalToSell++;
    }
    if (Indicator == 8 || Indicator2 == 8 || Indicator3 == 8) {
          double WPRCurrent = iWPR(NULL, NULL,WPRPeriod,1);       
          if (WPRCurrent < -100-WPRSignal) SignalToBuy++;
          if (WPRCurrent > WPRSignal) SignalToSell++;
    }
    if (Indicator == 9 || Indicator2 == 9 || Indicator3 == 9) {
          string PushStochMethod = StochMethod;
          double StochCurrent = iStochastic(NULL,NULL,StochKperiod,StochDperiod,StochSlow,PushStochMethod,0,MODE_MAIN,0);       
          if (StochCurrent < 100 - StochSignal) SignalToBuy++;
          if (StochCurrent > StochSignal) SignalToSell++;
    }
     if (Indicator == 10 || Indicator2 == 10 || Indicator3 == 10) {
          double DeMarkCurrent = iDeMarker(NULL,NULL,DeMarkPeriod,1);
  
          if (DeMarkCurrent < 1 - DeMarkSignal) SignalToBuy++;
          if (DeMarkCurrent > DeMarkSignal) SignalToSell++;
    }
    
    
    if (SignalToBuy >= SignalCount)
    {
        if (Martingale) BuyOrderLotsMgm();
        if (!Martingale) BuyOrder();
                 
    }
     if (SignalToSell >= SignalCount)
    {
        if (Martingale) SellOrderLotsMgm();
        if (!Martingale) SellOrder();      
    }
 }


void BuyOrder()
{
    double SL = Ask - StopLoss*PipValue*Point;
    if (StopLoss == 0) SL = 0;
    double TP = Ask + TakeProfit*PipValue*Point;
    if (TakeProfit == 0) TP = 0;
    int ticket = -1;
    if (true)
    ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, 4, 0, 0, "My Expert", 1, 0, Blue);
    else
    ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, 4, SL, TP, "My Expert", 1, 0, Blue);
    if (ticket > -1)
    {
        if (true)
        {
            OrderSelect(ticket, SELECT_BY_TICKET);
            bool ret = OrderModify(OrderTicket(), OrderOpenPrice(), SL, TP, 0, Blue);
            if (ret == false)
            Print("OrderModify() error - ", ErrorDescription(GetLastError()));
        }
            
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
}

void BuyOrderLotsMgm()
{
    double profit = 0;
    datetime lastCloseTime = 0;
    int cnt = OrdersHistoryTotal();
    for (int i=0; i < cnt; i++)
    {
        if (!OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) continue;
        if (OrderSymbol() == Symbol() && OrderMagicNumber() == 1 && lastCloseTime < OrderCloseTime())
        {
            lastCloseTime = OrderCloseTime();
            profit = OrderProfit();
            CurrentBuyLots = OrderLots();     // take lots from the last order
        }
    }
    
    if (profit > 0)     // had profit
    {
        CurrentBuyLots = Lots;
    }
    else if (profit < 0)    // had loss
    {
        CurrentBuyLots = CurrentBuyLots * LotMultiple;
    }
    double lotvalue = CurrentBuyLots;
    
    if (lotvalue < MarketInfo(Symbol(), MODE_MINLOT))    // make sure lot is not smaller than allowed value
    {
        lotvalue = MarketInfo(Symbol(), MODE_MINLOT);
    }
    if (lotvalue > MarketInfo(Symbol(), MODE_MAXLOT))    // make sure lot is not greater than allowed value
    {
        lotvalue = MarketInfo(Symbol(), MODE_MAXLOT);
    }
    double SL = Ask - StopLoss*PipValue*Point;
    if (StopLoss == 0) SL = 0;
    double TP = Ask + TakeProfit*PipValue*Point;
    if (TakeProfit == 0) TP = 0;
    FirstBuyLotsMgm = false;
    int ticket = -1;
    if (true)
    ticket = OrderSend(Symbol(), OP_BUY, lotvalue, Ask, 4, 0, 0, "My Expert", 1, 0, Blue);
    else
    ticket = OrderSend(Symbol(), OP_BUY, lotvalue, Ask, 4, SL, TP, "My Expert", 1, 0, Blue);
    if (ticket > -1)
    {
        if (true)
        {
            OrderSelect(ticket, SELECT_BY_TICKET);
            bool ret = OrderModify(OrderTicket(), OrderOpenPrice(), SL, TP, 0, Blue);
            if (ret == false)
            Print("OrderModify() error - ", ErrorDescription(GetLastError()));
        }
            
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
}



void SellOrder()
{
    double SL = Bid + StopLoss*PipValue*Point;
    if (StopLoss == 0) SL = 0;
    double TP = Bid - TakeProfit*PipValue*Point;
    if (TakeProfit == 0) TP = 0;
    int ticket = -1;
    if (true)
    ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, 4, 0, 0, "My Expert", 1, 0, Red);
    else
    ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, 4, SL, TP, "My Expert", 1, 0, Red);
    if (ticket > -1)
    {
        if (true)
        {
            OrderSelect(ticket, SELECT_BY_TICKET);
            bool ret = OrderModify(OrderTicket(), OrderOpenPrice(), SL, TP, 0, Red);
            if (ret == false)
            Print("OrderModify() error - ", ErrorDescription(GetLastError()));
        }
            
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
}

void SellOrderLotsMgm()
{
    double profit = 0;
    datetime lastCloseTime = 0;
    int cnt = OrdersHistoryTotal();
    for (int i=0; i < cnt; i++)
    {
        if (!OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) continue;
        if (OrderSymbol() == Symbol() && OrderMagicNumber() == 1 && lastCloseTime < OrderCloseTime())
        {
            lastCloseTime = OrderCloseTime();
            profit = OrderProfit();
            CurrentSellLots = OrderLots();
        }
    }
    
    if (profit > 0)     // had profit
    {
        CurrentSellLots = Lots;
    }
    else if (profit < 0)    // had loss
    {
        CurrentSellLots = CurrentSellLots * LotMultiple;;
    }
    double lotvalue = CurrentSellLots;
    
    if (lotvalue < MarketInfo(Symbol(), MODE_MINLOT))    // make sure lot is not smaller than allowed value
    {
        lotvalue = MarketInfo(Symbol(), MODE_MINLOT);
    }
    if (lotvalue > MarketInfo(Symbol(), MODE_MAXLOT))    // make sure lot is not greater than allowed value
    {
        lotvalue = MarketInfo(Symbol(), MODE_MAXLOT);
    }
    
    double SL = Bid + StopLoss*PipValue*Point;
    if (StopLoss == 0) SL = 0;
    double TP = Bid - TakeProfit*PipValue*Point;
    if (TakeProfit == 0) TP = 0;
    FirstSellLotsMgm = false;
    int ticket = -1;
    if (true)
    ticket = OrderSend(Symbol(), OP_SELL, lotvalue, Bid, 4, 0, 0, "My Expert", 1, 0, Red);
    else
    ticket = OrderSend(Symbol(), OP_SELL, lotvalue, Bid, 4, SL, TP, "My Expert", 1, 0, Red);
    if (ticket > -1)
    {
        if (true)
        {
            OrderSelect(ticket, SELECT_BY_TICKET);
            bool ret = OrderModify(OrderTicket(), OrderOpenPrice(), SL, TP, 0, Red);
            if (ret == false)
            Print("OrderModify() error - ", ErrorDescription(GetLastError()));
        }
            
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
}



int deinit()
{
    if (false) ObjectsDeleteAll();
    
    return (0);
}

